function varargout = mahademo(varargin)
% MAHADEMO M-file for mahademo.fig
%      MAHADEMO, by itself, creates a new MAHADEMO or raises the existing
%      singleton*.
%
%      H = MAHADEMO returns the handle to a new MAHADEMO or the handle to
%      the existing singleton*.
%
%      MAHADEMO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MAHADEMO.M with the given input arguments.
%
%      MAHADEMO('Property','Value',...) creates a new MAHADEMO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mahademo_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mahademo_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the respadonse to help mahademo

% Last Modified by GUIDE v2.5 14-Jan-2013 07:06:02

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @mahademo_OpeningFcn, ...
                   'gui_OutputFcn',  @mahademo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mahademo is made visible.
function mahademo_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to mahademo (see VARARGIN)

% Choose default command line output for mahademo
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes mahademo wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = mahademo_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in addpoints.
function addpoints_Callback(hObject, eventdata, handles)
% hObject    handle to addpoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of addpoints
[x,y]=getpts(handles.axespoints);


if get(handles.labelspanel,'SelectedObject')==handles.label1,
    lab=1;
elseif get(handles.labelspanel,'SelectedObject')==handles.label2,
    lab=2;
elseif get(handles.labelspanel,'SelectedObject')==handles.label3,
    lab=3;
end
get(handles.labelspanel,'SelectedObject')

T=get(handles.graph,'UserData');
T=[T;[x,y,lab*ones(length(x),1)]];
set(handles.graph,'UserData',T);
knn(handles);
redrawgraph(handles);

function redrawgraph(handles)
cla(handles.axespoints);
xlim([-10,10]);
ylim([-10,10]);
T=get(handles.graph,'UserData');
colorpoint={'r','b','k'};
markerpoint={'o','s','d'};
axes(handles.axespoints);
hold on;
for i=1:3,
    scatter(T(find(T(:,end)==i),1),T(find(T(:,end)==i),2),60,colorpoint{i},markerpoint{i},'filled');
end
knn(handles);

M=get(handles.mahala,'Data');

Ellipse_plot(M,T(1,1:2));



function knn(handles);
T=get(handles.graph,'UserData');
kk=str2num(get(handles.knn,'String'));
X=T(:,1:2);
Y=T(:,3);

D=get(handles.mahala,'Data');

Dnn=zeros(length(Y));
for i=1:length(Y),
    for j=i+1:length(Y),
        Dnn(i,j)=(X(i,:)-X(j,:))*D*(X(i,:)-X(j,:))';
    end
end
Dnn=Dnn+Dnn'

[Val,IDX]=sort(Dnn,'ascend');
error=0;

for i=1:length(Y),
    if Y(i)~=knnmajority(Y(IDX(2:2+kk-1,i))),
        error=error+1/length(Y);
    end    
end

set(handles.error,'String',num2str(error));





function label=knnmajority(orderedLabelList) % function to compute vote in knn with multiclass
weights=1-(1:length(orderedLabelList))/10000000; % give slightly higher weight to closer neighbors to cut ties.
maxl=max(orderedLabelList);

counts=zeros(1,maxl);

for i=1:length(orderedLabelList),
    counts(orderedLabelList(i))=counts(orderedLabelList(i))+weights(i);
end
[~,label]=max(counts);


% --- Executes when entered data in editable cell(s) in mahala.
function mahala_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to mahala (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
M=get(handles.mahala,'Data');
if eventdata.Indices==[2,1],
    M(1,2)=M(2,1);
elseif eventdata.Indices==[1,2],
    M(2,1)=M(1,2);
end
set(handles.mahala,'Data',M);
redrawgraph(handles)


function knn_Callback(hObject, eventdata, handles)
% hObject    handle to knn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of knn as text
%        str2double(get(hObject,'String')) returns contents of knn as a double
knn(handles)


% --- Executes during object creation, after setting all properties.
function knn_CreateFcn(hObject, eventdata, handles)
% hObject    handle to knn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in lmnn.
function lmnn_Callback(hObject, eventdata, handles)
% hObject    handle to lmnn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
T=get(handles.graph,'UserData');
[L,~]=lmnn(T(:,1:2)',T(:,3)');
set(handles.mahala,'Data',L'*L);
knn(handles);
redrawgraph(handles);


% --- Executes on button press in itml.
function itml_Callback(hObject, eventdata, handles)
% hObject    handle to itml (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
T=get(handles.graph,'UserData');
L=MetricLearningAutotuneKnn(@ItmlAlg, T(:,3), T(:,1:2));
set(handles.mahala,'Data',L'*L);
knn(handles);
redrawgraph(handles);



% --- Executes on button press in empcov.
function empcov_Callback(hObject, eventdata, handles)
% hObject    handle to empcov (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
T=get(handles.graph,'UserData');
M=cov(T(:,1:2));
M=M/(.5*trace(M));
M=inv(M);
set(handles.mahala,'Data',M);
knn(handles);
redrawgraph(handles);


% --- Executes during object creation, after setting all properties.
function axespoints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axespoints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axespoints
set(hObject,'XLim',[-10,10]);
set(hObject,'YLim',[-10,10]);


% --- Executes on button press in clearbutton.
function clearbutton_Callback(hObject, eventdata, handles)
% hObject    handle to clearbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of clearbutton
set(handles.graph,'UserData',[]);
redrawgraph(handles);
